<?php
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *                                   ATTENTION!
 * If you see this message in your browser (Internet Explorer, Mozilla Firefox, Google Chrome, etc.)
 * this means that PHP is not properly installed on your web server. Please refer to the PHP manual
 * for more details: http://php.net/manual/install.php 
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

    include_once dirname(__FILE__) . '/components/startup.php';
    include_once dirname(__FILE__) . '/components/application.php';
    include_once dirname(__FILE__) . '/' . 'authorization.php';


    include_once dirname(__FILE__) . '/' . 'database_engine/pgsql_engine.php';
    include_once dirname(__FILE__) . '/' . 'components/page/page_includes.php';

    function GetConnectionOptions()
    {
        $result = GetGlobalConnectionOptions();
        $result['client_encoding'] = 'utf8';
        GetApplication()->GetUserAuthentication()->applyIdentityToConnectionOptions($result);
        return $result;
    }

    
    
    
    // OnBeforePageExecute event handler
    
    
    
    class public_contact_edm_glnPage extends Page
    {
        protected function DoBeforeCreate()
        {
            $this->SetTitle('');
            $this->SetMenuLabel('GLN Vorlagen');
            $this->SetHeader(GetPagesHeader());
            $this->SetFooter(GetPagesFooter());
    
            $this->dataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $this->dataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $this->dataset->AddLookupField('action_gln', 'public.tariff_edm_activity_types', new StringField('activity_type'), new StringField('description', false, false, false, false, 'LA1', 'LT1'), 'LT1');
            $this->dataset->AddLookupField('origin_site', 'public.contact_edm_gln', new StringField('gln'), new StringField('description', false, false, false, false, 'LA2', 'LT2'), 'LT2');
            $this->dataset->AddLookupField('destination_site', 'public.contact_edm_gln', new StringField('gln'), new StringField('description', false, false, false, false, 'LA3', 'LT3'), 'LT3');
            $this->dataset->AddLookupField('site_gln', 'public.qwaste_catalog', new StringField('gtin'), new StringField('selector', false, false, false, false, 'LA4', 'LT4'), 'LT4');
        }
    
        protected function DoPrepare() {
    
        }
    
        protected function CreatePageNavigator()
        {
            $result = new CompositePageNavigator($this);
            
            $partitionNavigator = new PageNavigator('pnav', $this, $this->dataset);
            $partitionNavigator->SetRowsPerPage(10);
            $result->AddPageNavigator($partitionNavigator);
            
            return $result;
        }
    
        protected function CreateRssGenerator()
        {
            return null;
        }
    
        protected function setupCharts()
        {
    
        }
    
        protected function getFiltersColumns()
        {
            return array(
                new FilterColumn($this->dataset, 'gln', 'gln', 'GLN'),
                new FilterColumn($this->dataset, 'type', 'type', 'Typ'),
                new FilterColumn($this->dataset, 'description', 'description', 'Bezeichnung'),
                new FilterColumn($this->dataset, 'street', 'street', 'Straße'),
                new FilterColumn($this->dataset, 'zip', 'zip', 'PLZ'),
                new FilterColumn($this->dataset, 'city', 'city', 'Stadt'),
                new FilterColumn($this->dataset, 'country', 'country', 'Land'),
                new FilterColumn($this->dataset, 'method_gln', 'method_gln', 'Verfahren GLN'),
                new FilterColumn($this->dataset, 'method_text', 'method_text', 'Verfahren Text'),
                new FilterColumn($this->dataset, 'action_gln', 'LA1', 'Buchungsart'),
                new FilterColumn($this->dataset, 'origin_site', 'LA2', 'Herkunft Anlage'),
                new FilterColumn($this->dataset, 'destination_site', 'LA3', 'Verbleib Anlage'),
                new FilterColumn($this->dataset, 'site_gln', 'LA4', 'Abfall GLN'),
                new FilterColumn($this->dataset, 'origin_single_msg_type', 'origin_single_msg_type', 'Deponie Einzelmeldung'),
                new FilterColumn($this->dataset, 'origin_person', 'origin_person', 'Herkunft Person'),
                new FilterColumn($this->dataset, 'origin_location', 'origin_location', 'Herkunft Standort'),
                new FilterColumn($this->dataset, 'destination_person', 'destination_person', 'Verbleib Person'),
                new FilterColumn($this->dataset, 'destination_location', 'destination_location', 'Verbleib Standort'),
                new FilterColumn($this->dataset, 'street_extension', 'street_extension', 'Straße Zusatz'),
                new FilterColumn($this->dataset, 'location_gln', 'location_gln', 'Standort GLN')
            );
        }
    
        protected function setupQuickFilter(QuickFilter $quickFilter, FixedKeysArray $columns)
        {
            $quickFilter
                ->addColumn($columns['gln'])
                ->addColumn($columns['type'])
                ->addColumn($columns['description'])
                ->addColumn($columns['street'])
                ->addColumn($columns['zip'])
                ->addColumn($columns['city'])
                ->addColumn($columns['country'])
                ->addColumn($columns['method_gln'])
                ->addColumn($columns['method_text'])
                ->addColumn($columns['action_gln'])
                ->addColumn($columns['origin_site'])
                ->addColumn($columns['destination_site'])
                ->addColumn($columns['site_gln'])
                ->addColumn($columns['origin_single_msg_type']);
        }
    
        protected function setupColumnFilter(ColumnFilter $columnFilter)
        {
            $columnFilter
                ->setOptionsFor('gln')
                ->setOptionsFor('type')
                ->setOptionsFor('description')
                ->setOptionsFor('street')
                ->setOptionsFor('zip')
                ->setOptionsFor('city')
                ->setOptionsFor('country')
                ->setOptionsFor('action_gln')
                ->setOptionsFor('origin_site')
                ->setOptionsFor('destination_site')
                ->setOptionsFor('site_gln')
                ->setOptionsFor('origin_single_msg_type');
        }
    
        protected function setupFilterBuilder(FilterBuilder $filterBuilder, FixedKeysArray $columns)
        {
            $main_editor = new TextEdit('gln_edit');
            
            $filterBuilder->addColumn(
                $columns['gln'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new ComboBox('type_edit', $this->GetLocalizerCaptions()->GetMessageString('PleaseSelect'));
            $main_editor->addChoice('Anlage', 'Anlage');
            $main_editor->addChoice('Kontakt', 'Kontakt');
            $main_editor->addChoice('Report', 'Report');
            $main_editor->addChoice('Steuerung', 'Steuerung');
            $main_editor->addChoice('Person', 'Person');
            $main_editor->addChoice('Verfahren', 'Verfahren');
            $main_editor->addChoice('Branche', 'Branche');
            $main_editor->SetAllowNullValue(false);
            
            $multi_value_select_editor = new MultiValueSelect('type');
            $multi_value_select_editor->setChoices($main_editor->getChoices());
            
            $text_editor = new TextEdit('type');
            
            $filterBuilder->addColumn(
                $columns['type'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $text_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $text_editor,
                    FilterConditionOperator::BEGINS_WITH => $text_editor,
                    FilterConditionOperator::ENDS_WITH => $text_editor,
                    FilterConditionOperator::IS_LIKE => $text_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $text_editor,
                    FilterConditionOperator::IN => $multi_value_select_editor,
                    FilterConditionOperator::NOT_IN => $multi_value_select_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('description');
            
            $filterBuilder->addColumn(
                $columns['description'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('street_edit');
            
            $filterBuilder->addColumn(
                $columns['street'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('zip_edit');
            
            $filterBuilder->addColumn(
                $columns['zip'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('city_edit');
            
            $filterBuilder->addColumn(
                $columns['city'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('country_edit');
            
            $filterBuilder->addColumn(
                $columns['country'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('method_gln_edit');
            
            $filterBuilder->addColumn(
                $columns['method_gln'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('method_text_edit');
            
            $filterBuilder->addColumn(
                $columns['method_text'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new DynamicCombobox('action_gln_edit', $this->CreateLinkBuilder());
            $main_editor->setAllowClear(true);
            $main_editor->setMinimumInputLength(0);
            $main_editor->SetAllowNullValue(false);
            $main_editor->SetHandlerName('filter_builder_public_contact_edm_gln_action_gln_search');
            
            $multi_value_select_editor = new RemoteMultiValueSelect('action_gln', $this->CreateLinkBuilder());
            $multi_value_select_editor->SetHandlerName('filter_builder_public_contact_edm_gln_action_gln_search');
            
            $text_editor = new TextEdit('action_gln');
            
            $filterBuilder->addColumn(
                $columns['action_gln'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $text_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $text_editor,
                    FilterConditionOperator::BEGINS_WITH => $text_editor,
                    FilterConditionOperator::ENDS_WITH => $text_editor,
                    FilterConditionOperator::IS_LIKE => $text_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $text_editor,
                    FilterConditionOperator::IN => $multi_value_select_editor,
                    FilterConditionOperator::NOT_IN => $multi_value_select_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new DynamicCombobox('origin_site_edit', $this->CreateLinkBuilder());
            $main_editor->setAllowClear(true);
            $main_editor->setMinimumInputLength(0);
            $main_editor->SetAllowNullValue(false);
            $main_editor->SetHandlerName('filter_builder_public_contact_edm_gln_origin_site_search');
            
            $multi_value_select_editor = new RemoteMultiValueSelect('origin_site', $this->CreateLinkBuilder());
            $multi_value_select_editor->SetHandlerName('filter_builder_public_contact_edm_gln_origin_site_search');
            
            $text_editor = new TextEdit('origin_site');
            
            $filterBuilder->addColumn(
                $columns['origin_site'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $text_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $text_editor,
                    FilterConditionOperator::BEGINS_WITH => $text_editor,
                    FilterConditionOperator::ENDS_WITH => $text_editor,
                    FilterConditionOperator::IS_LIKE => $text_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $text_editor,
                    FilterConditionOperator::IN => $multi_value_select_editor,
                    FilterConditionOperator::NOT_IN => $multi_value_select_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new DynamicCombobox('destination_site_edit', $this->CreateLinkBuilder());
            $main_editor->setAllowClear(true);
            $main_editor->setMinimumInputLength(0);
            $main_editor->SetAllowNullValue(false);
            $main_editor->SetHandlerName('filter_builder_public_contact_edm_gln_destination_site_search');
            
            $multi_value_select_editor = new RemoteMultiValueSelect('destination_site', $this->CreateLinkBuilder());
            $multi_value_select_editor->SetHandlerName('filter_builder_public_contact_edm_gln_destination_site_search');
            
            $text_editor = new TextEdit('destination_site');
            
            $filterBuilder->addColumn(
                $columns['destination_site'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $text_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $text_editor,
                    FilterConditionOperator::BEGINS_WITH => $text_editor,
                    FilterConditionOperator::ENDS_WITH => $text_editor,
                    FilterConditionOperator::IS_LIKE => $text_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $text_editor,
                    FilterConditionOperator::IN => $multi_value_select_editor,
                    FilterConditionOperator::NOT_IN => $multi_value_select_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new DynamicCombobox('site_gln_edit', $this->CreateLinkBuilder());
            $main_editor->setAllowClear(true);
            $main_editor->setMinimumInputLength(0);
            $main_editor->SetAllowNullValue(false);
            $main_editor->SetHandlerName('filter_builder_public_contact_edm_gln_site_gln_search');
            
            $multi_value_select_editor = new RemoteMultiValueSelect('site_gln', $this->CreateLinkBuilder());
            $multi_value_select_editor->SetHandlerName('filter_builder_public_contact_edm_gln_site_gln_search');
            
            $text_editor = new TextEdit('site_gln');
            
            $filterBuilder->addColumn(
                $columns['site_gln'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $text_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $text_editor,
                    FilterConditionOperator::BEGINS_WITH => $text_editor,
                    FilterConditionOperator::ENDS_WITH => $text_editor,
                    FilterConditionOperator::IS_LIKE => $text_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $text_editor,
                    FilterConditionOperator::IN => $multi_value_select_editor,
                    FilterConditionOperator::NOT_IN => $multi_value_select_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('origin_single_msg_type_edit');
            
            $filterBuilder->addColumn(
                $columns['origin_single_msg_type'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
        }
    
        protected function AddOperationsColumns(Grid $grid)
        {
            $actions = $grid->getActions();
            $actions->setCaption($this->GetLocalizerCaptions()->GetMessageString('Actions'));
            $actions->setPosition(ActionList::POSITION_LEFT);
            
            if ($this->GetSecurityInfo()->HasViewGrant())
            {
                $operation = new AjaxOperation(OPERATION_VIEW,
                    $this->GetLocalizerCaptions()->GetMessageString('View'),
                    $this->GetLocalizerCaptions()->GetMessageString('View'), $this->dataset,
                    $this->GetModalGridViewHandler(), $grid);
                $operation->setUseImage(true);
                $actions->addOperation($operation);
            }
            
            if ($this->GetSecurityInfo()->HasEditGrant())
            {
                $operation = new AjaxOperation(OPERATION_EDIT,
                    $this->GetLocalizerCaptions()->GetMessageString('Edit'),
                    $this->GetLocalizerCaptions()->GetMessageString('Edit'), $this->dataset,
                    $this->GetGridEditHandler(), $grid);
                $operation->setUseImage(true);
                $actions->addOperation($operation);
                $operation->OnShow->AddListener('ShowEditButtonHandler', $this);
            }
            
            if ($this->GetSecurityInfo()->HasDeleteGrant())
            {
                $operation = new LinkOperation($this->GetLocalizerCaptions()->GetMessageString('Delete'), OPERATION_DELETE, $this->dataset, $grid);
                $operation->setUseImage(true);
                $actions->addOperation($operation);
                $operation->OnShow->AddListener('ShowDeleteButtonHandler', $this);
                $operation->SetAdditionalAttribute('data-modal-operation', 'delete');
                $operation->SetAdditionalAttribute('data-delete-handler-name', $this->GetModalGridDeleteHandler());
            }
        }
    
        protected function AddFieldColumns(Grid $grid, $withDetails = true)
        {
            //
            // View column for gln field
            //
            $column = new TextViewColumn('gln', 'gln', 'GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_gln_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for type field
            //
            $column = new TextViewColumn('type', 'type', 'Typ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_type_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('description', 'description', 'Beschreibung', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_description_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for street field
            //
            $column = new TextViewColumn('street', 'street', 'Straße', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_street_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for zip field
            //
            $column = new TextViewColumn('zip', 'zip', 'PLZ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_zip_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for city field
            //
            $column = new TextViewColumn('city', 'city', 'Stadt', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_city_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for country field
            //
            $column = new TextViewColumn('country', 'country', 'Land', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_country_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for method_gln field
            //
            $column = new TextViewColumn('method_gln', 'method_gln', 'Verfahren GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_method_gln_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for method_text field
            //
            $column = new TextViewColumn('method_text', 'method_text', 'Verfahren Text', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_method_text_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('action_gln', 'LA1', 'Buchungsart', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_LA1_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('origin_site', 'LA2', 'Herkunft Anlage', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_LA2_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('destination_site', 'LA3', 'Verbleib Anlage', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_LA3_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('site_gln', 'LA4', 'Abfall GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_LA4_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for origin_single_msg_type field
            //
            $column = new TextViewColumn('origin_single_msg_type', 'origin_single_msg_type', 'Deponie Einzelmeldung', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_origin_single_msg_type_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
        }
    
        protected function AddSingleRecordViewColumns(Grid $grid)
        {
            //
            // View column for gln field
            //
            $column = new TextViewColumn('gln', 'gln', 'GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_gln_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for type field
            //
            $column = new TextViewColumn('type', 'type', 'Typ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_type_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('description', 'description', 'Bezeichnung', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_description_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for street field
            //
            $column = new TextViewColumn('street', 'street', 'Straße', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_street_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for zip field
            //
            $column = new TextViewColumn('zip', 'zip', 'PLZ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_zip_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for city field
            //
            $column = new TextViewColumn('city', 'city', 'Stadt', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_city_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for country field
            //
            $column = new TextViewColumn('country', 'country', 'Land', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_country_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for method_gln field
            //
            $column = new TextViewColumn('method_gln', 'method_gln', 'Verfahren GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_method_gln_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for method_text field
            //
            $column = new TextViewColumn('method_text', 'method_text', 'Verfahren Text', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_method_text_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('action_gln', 'LA1', 'Buchungsart', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_LA1_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('origin_site', 'LA2', 'Herkunft Anlage', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_LA2_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('destination_site', 'LA3', 'Verbleib Anlage', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_LA3_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('site_gln', 'LA4', 'Abfall GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_LA4_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for origin_single_msg_type field
            //
            $column = new TextViewColumn('origin_single_msg_type', 'origin_single_msg_type', 'Deponie Einzelmeldung', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_origin_single_msg_type_handler_view');
            $grid->AddSingleRecordViewColumn($column);
        }
    
        protected function AddEditColumns(Grid $grid)
        {
            //
            // Edit column for gln field
            //
            $editor = new TextEdit('gln_edit');
            $editColumn = new CustomEditColumn('GLN', 'gln', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for type field
            //
            $editor = new ComboBox('type_edit', $this->GetLocalizerCaptions()->GetMessageString('PleaseSelect'));
            $editor->addChoice('Anlage', 'Anlage');
            $editor->addChoice('Kontakt', 'Kontakt');
            $editor->addChoice('Report', 'Report');
            $editor->addChoice('Steuerung', 'Steuerung');
            $editor->addChoice('Person', 'Person');
            $editor->addChoice('Verfahren', 'Verfahren');
            $editor->addChoice('Branche', 'Branche');
            $editColumn = new CustomEditColumn('Typ', 'type', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for description field
            //
            $editor = new TextAreaEdit('description_edit', 50, 8);
            $editColumn = new CustomEditColumn('Bezeichnung', 'description', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for street field
            //
            $editor = new TextEdit('street_edit');
            $editColumn = new CustomEditColumn('Straße', 'street', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for zip field
            //
            $editor = new TextEdit('zip_edit');
            $editColumn = new CustomEditColumn('PLZ', 'zip', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for city field
            //
            $editor = new TextEdit('city_edit');
            $editColumn = new CustomEditColumn('Stadt', 'city', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for country field
            //
            $editor = new TextEdit('country_edit');
            $editColumn = new CustomEditColumn('Land', 'country', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for method_gln field
            //
            $editor = new TextEdit('method_gln_edit');
            $editColumn = new CustomEditColumn('Verfahren GLN', 'method_gln', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for method_text field
            //
            $editor = new TextEdit('method_text_edit');
            $editColumn = new CustomEditColumn('Verfahren Text', 'method_text', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for action_gln field
            //
            $editor = new ComboBox('action_gln_edit', $this->GetLocalizerCaptions()->GetMessageString('PleaseSelect'));
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."tariff_edm_activity_types"');
            $lookupDataset->addFields(
                array(
                    new StringField('activity_type', true, true),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new LookUpEditColumn(
                'Buchungsart', 
                'action_gln', 
                $editor, 
                $this->dataset, 'activity_type', 'description', $lookupDataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for origin_site field
            //
            $editor = new DynamicCombobox('origin_site_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Herkunft Anlage', 'origin_site', 'LA2', 'edit_public_contact_edm_gln_origin_site_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for destination_site field
            //
            $editor = new DynamicCombobox('destination_site_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Verbleib Anlage', 'destination_site', 'LA3', 'edit_public_contact_edm_gln_destination_site_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for site_gln field
            //
            $editor = new DynamicCombobox('site_gln_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qwaste_catalog"');
            $lookupDataset->addFields(
                array(
                    new StringField('gtin'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Abfall GLN', 'site_gln', 'LA4', 'edit_public_contact_edm_gln_site_gln_search', $editor, $this->dataset, $lookupDataset, 'gtin', 'selector', '');
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for origin_single_msg_type field
            //
            $editor = new TextEdit('origin_single_msg_type_edit');
            $editColumn = new CustomEditColumn('Deponie Einzelmeldung', 'origin_single_msg_type', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
        }
    
        protected function AddMultiEditColumns(Grid $grid)
        {
            //
            // Edit column for gln field
            //
            $editor = new TextEdit('gln_edit');
            $editColumn = new CustomEditColumn('GLN', 'gln', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for type field
            //
            $editor = new ComboBox('type_edit', $this->GetLocalizerCaptions()->GetMessageString('PleaseSelect'));
            $editor->addChoice('Anlage', 'Anlage');
            $editor->addChoice('Kontakt', 'Kontakt');
            $editor->addChoice('Report', 'Report');
            $editor->addChoice('Steuerung', 'Steuerung');
            $editor->addChoice('Person', 'Person');
            $editor->addChoice('Verfahren', 'Verfahren');
            $editor->addChoice('Branche', 'Branche');
            $editColumn = new CustomEditColumn('Typ', 'type', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for description field
            //
            $editor = new TextAreaEdit('description_edit', 50, 8);
            $editColumn = new CustomEditColumn('Beschreibung', 'description', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for street field
            //
            $editor = new TextEdit('street_edit');
            $editColumn = new CustomEditColumn('Straße', 'street', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for zip field
            //
            $editor = new TextEdit('zip_edit');
            $editColumn = new CustomEditColumn('PLZ', 'zip', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for city field
            //
            $editor = new TextEdit('city_edit');
            $editColumn = new CustomEditColumn('Stadt', 'city', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for country field
            //
            $editor = new TextEdit('country_edit');
            $editColumn = new CustomEditColumn('Land', 'country', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for method_gln field
            //
            $editor = new TextEdit('method_gln_edit');
            $editColumn = new CustomEditColumn('Verfahren GLN', 'method_gln', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for method_text field
            //
            $editor = new TextEdit('method_text_edit');
            $editColumn = new CustomEditColumn('Verfahren Text', 'method_text', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for action_gln field
            //
            $editor = new ComboBox('action_gln_edit', $this->GetLocalizerCaptions()->GetMessageString('PleaseSelect'));
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."tariff_edm_activity_types"');
            $lookupDataset->addFields(
                array(
                    new StringField('activity_type', true, true),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new LookUpEditColumn(
                'Buchungsart', 
                'action_gln', 
                $editor, 
                $this->dataset, 'activity_type', 'description', $lookupDataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for origin_site field
            //
            $editor = new DynamicCombobox('origin_site_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Herkunft Anlage', 'origin_site', 'LA2', 'multi_edit_public_contact_edm_gln_origin_site_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for destination_site field
            //
            $editor = new DynamicCombobox('destination_site_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Verbleib Anlage', 'destination_site', 'LA3', 'multi_edit_public_contact_edm_gln_destination_site_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for site_gln field
            //
            $editor = new DynamicCombobox('site_gln_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qwaste_catalog"');
            $lookupDataset->addFields(
                array(
                    new StringField('gtin'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Abfall GLN', 'site_gln', 'LA4', 'multi_edit_public_contact_edm_gln_site_gln_search', $editor, $this->dataset, $lookupDataset, 'gtin', 'selector', '');
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for origin_single_msg_type field
            //
            $editor = new TextEdit('origin_single_msg_type_edit');
            $editColumn = new CustomEditColumn('Deponie Einzelmeldung', 'origin_single_msg_type', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
        }
    
        protected function AddInsertColumns(Grid $grid)
        {
            //
            // Edit column for gln field
            //
            $editor = new TextEdit('gln_edit');
            $editColumn = new CustomEditColumn('GLN', 'gln', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for type field
            //
            $editor = new ComboBox('type_edit', $this->GetLocalizerCaptions()->GetMessageString('PleaseSelect'));
            $editor->addChoice('Anlage', 'Anlage');
            $editor->addChoice('Kontakt', 'Kontakt');
            $editor->addChoice('Report', 'Report');
            $editor->addChoice('Steuerung', 'Steuerung');
            $editor->addChoice('Person', 'Person');
            $editor->addChoice('Verfahren', 'Verfahren');
            $editor->addChoice('Branche', 'Branche');
            $editColumn = new CustomEditColumn('Typ', 'type', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for description field
            //
            $editor = new TextAreaEdit('description_edit', 50, 8);
            $editColumn = new CustomEditColumn('Bezeichnung', 'description', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for street field
            //
            $editor = new TextEdit('street_edit');
            $editColumn = new CustomEditColumn('Straße', 'street', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for zip field
            //
            $editor = new TextEdit('zip_edit');
            $editColumn = new CustomEditColumn('PLZ', 'zip', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for city field
            //
            $editor = new TextEdit('city_edit');
            $editColumn = new CustomEditColumn('Stadt', 'city', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for country field
            //
            $editor = new TextEdit('country_edit');
            $editColumn = new CustomEditColumn('Land', 'country', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for method_gln field
            //
            $editor = new TextEdit('method_gln_edit');
            $editColumn = new CustomEditColumn('Verfahren GLN', 'method_gln', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for method_text field
            //
            $editor = new TextEdit('method_text_edit');
            $editColumn = new CustomEditColumn('Verfahren Text', 'method_text', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for action_gln field
            //
            $editor = new ComboBox('action_gln_edit', $this->GetLocalizerCaptions()->GetMessageString('PleaseSelect'));
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."tariff_edm_activity_types"');
            $lookupDataset->addFields(
                array(
                    new StringField('activity_type', true, true),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new LookUpEditColumn(
                'Buchungsart', 
                'action_gln', 
                $editor, 
                $this->dataset, 'activity_type', 'description', $lookupDataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for origin_site field
            //
            $editor = new DynamicCombobox('origin_site_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Herkunft Anlage', 'origin_site', 'LA2', 'insert_public_contact_edm_gln_origin_site_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for destination_site field
            //
            $editor = new DynamicCombobox('destination_site_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Verbleib Anlage', 'destination_site', 'LA3', 'insert_public_contact_edm_gln_destination_site_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for site_gln field
            //
            $editor = new DynamicCombobox('site_gln_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qwaste_catalog"');
            $lookupDataset->addFields(
                array(
                    new StringField('gtin'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Abfall GLN', 'site_gln', 'LA4', 'insert_public_contact_edm_gln_site_gln_search', $editor, $this->dataset, $lookupDataset, 'gtin', 'selector', '');
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for origin_single_msg_type field
            //
            $editor = new TextEdit('origin_single_msg_type_edit');
            $editColumn = new CustomEditColumn('Deponie Einzelmeldung', 'origin_single_msg_type', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            $grid->SetShowAddButton(true && $this->GetSecurityInfo()->HasAddGrant());
        }
    
        private function AddMultiUploadColumn(Grid $grid)
        {
    
        }
    
        protected function AddPrintColumns(Grid $grid)
        {
            //
            // View column for gln field
            //
            $column = new TextViewColumn('gln', 'gln', 'Gln', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_gln_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for type field
            //
            $column = new TextViewColumn('type', 'type', 'Typ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_type_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('description', 'description', 'Description', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_description_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for street field
            //
            $column = new TextViewColumn('street', 'street', 'Straße', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_street_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for zip field
            //
            $column = new TextViewColumn('zip', 'zip', 'PLZ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_zip_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for city field
            //
            $column = new TextViewColumn('city', 'city', 'Stadt', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_city_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for country field
            //
            $column = new TextViewColumn('country', 'country', 'Land', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_country_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for method_gln field
            //
            $column = new TextViewColumn('method_gln', 'method_gln', 'Method Gln', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_method_gln_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for method_text field
            //
            $column = new TextViewColumn('method_text', 'method_text', 'Verfahren Text', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_method_text_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('action_gln', 'LA1', 'Action Gln', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_LA1_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('origin_site', 'LA2', 'Origin Site', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_LA2_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('destination_site', 'LA3', 'Destination Site', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_LA3_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('site_gln', 'LA4', 'Abfall GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_LA4_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for origin_single_msg_type field
            //
            $column = new TextViewColumn('origin_single_msg_type', 'origin_single_msg_type', 'Deponie Einzelmeldung', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_origin_single_msg_type_handler_print');
            $grid->AddPrintColumn($column);
        }
    
        protected function AddExportColumns(Grid $grid)
        {
            //
            // View column for gln field
            //
            $column = new TextViewColumn('gln', 'gln', 'Gln', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_gln_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for type field
            //
            $column = new TextViewColumn('type', 'type', 'Typ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_type_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('description', 'description', 'Description', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_description_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for street field
            //
            $column = new TextViewColumn('street', 'street', 'Straße', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_street_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for zip field
            //
            $column = new TextViewColumn('zip', 'zip', 'PLZ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_zip_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for city field
            //
            $column = new TextViewColumn('city', 'city', 'Stadt', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_city_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for country field
            //
            $column = new TextViewColumn('country', 'country', 'Land', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_country_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for method_gln field
            //
            $column = new TextViewColumn('method_gln', 'method_gln', 'Method Gln', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_method_gln_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for method_text field
            //
            $column = new TextViewColumn('method_text', 'method_text', 'Verfahren Text', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_method_text_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('action_gln', 'LA1', 'Action Gln', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_LA1_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('origin_site', 'LA2', 'Origin Site', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_LA2_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('destination_site', 'LA3', 'Destination Site', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_LA3_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('site_gln', 'LA4', 'Abfall GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_LA4_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for origin_single_msg_type field
            //
            $column = new TextViewColumn('origin_single_msg_type', 'origin_single_msg_type', 'Deponie Einzelmeldung', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_origin_single_msg_type_handler_export');
            $grid->AddExportColumn($column);
        }
    
        private function AddCompareColumns(Grid $grid)
        {
            //
            // View column for gln field
            //
            $column = new TextViewColumn('gln', 'gln', 'GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_gln_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for type field
            //
            $column = new TextViewColumn('type', 'type', 'Typ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(30);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_type_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('description', 'description', 'Beschreibung', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_description_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for street field
            //
            $column = new TextViewColumn('street', 'street', 'Straße', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_street_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for zip field
            //
            $column = new TextViewColumn('zip', 'zip', 'PLZ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_zip_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for city field
            //
            $column = new TextViewColumn('city', 'city', 'Stadt', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_city_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for country field
            //
            $column = new TextViewColumn('country', 'country', 'Land', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_country_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for method_gln field
            //
            $column = new TextViewColumn('method_gln', 'method_gln', 'Verfahren GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_method_gln_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for method_text field
            //
            $column = new TextViewColumn('method_text', 'method_text', 'Verfahren Text', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_method_text_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('action_gln', 'LA1', 'Buchungsart', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_LA1_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('origin_site', 'LA2', 'Herkunft Anlage', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_LA2_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('destination_site', 'LA3', 'Verbleib Anlage', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_LA3_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('site_gln', 'LA4', 'Abfall GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(20);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_LA4_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for origin_single_msg_type field
            //
            $column = new TextViewColumn('origin_single_msg_type', 'origin_single_msg_type', 'Deponie Einzelmeldung', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_contact_edm_glnGrid_origin_single_msg_type_handler_compare');
            $grid->AddCompareColumn($column);
        }
    
        private function AddCompareHeaderColumns(Grid $grid)
        {
    
        }
    
        public function GetPageDirection()
        {
            return null;
        }
    
        public function isFilterConditionRequired()
        {
            return true;
        }
    
        protected function ApplyCommonColumnEditProperties(CustomEditColumn $column)
        {
            $column->SetDisplaySetToNullCheckBox(false);
            $column->SetDisplaySetToDefaultCheckBox(false);
    		$column->SetVariableContainer($this->GetColumnVariableContainer());
        }
    
        function GetCustomClientScript()
        {
            return ;
        }
        
        function GetOnPageLoadedClientScript()
        {
            return ;
        }
        
        public function GetEnableModalGridInsert() { return true; }
        public function GetEnableModalSingleRecordView() { return true; }
        
        public function GetEnableModalGridEdit() { return true; }
        
        protected function GetEnableModalGridDelete() { return true; }
    
        protected function CreateGrid()
        {
            $result = new Grid($this, $this->dataset);
            if ($this->GetSecurityInfo()->HasDeleteGrant())
               $result->SetAllowDeleteSelected(false);
            else
               $result->SetAllowDeleteSelected(false);   
            
            ApplyCommonPageSettings($this, $result);
            
            $result->SetUseImagesForActions(true);
            $defaultSortedColumns = array();
            $defaultSortedColumns[] = new SortColumn('gln', 'ASC');
            $result->setDefaultOrdering($defaultSortedColumns);
            $result->SetUseFixedHeader(false);
            $result->SetShowLineNumbers(false);
            $result->SetViewMode(ViewMode::TABLE);
            $result->setEnableRuntimeCustomization(true);
            $result->setAllowCompare(true);
            $this->AddCompareHeaderColumns($result);
            $this->AddCompareColumns($result);
            $result->setMultiEditAllowed($this->GetSecurityInfo()->HasEditGrant() && false);
            $result->setTableBordered(false);
            $result->setTableCondensed(false);
            
            $result->SetHighlightRowAtHover(false);
            $result->SetWidth('');
            $this->AddOperationsColumns($result);
            $this->AddFieldColumns($result);
            $this->AddSingleRecordViewColumns($result);
            $this->AddEditColumns($result);
            $this->AddMultiEditColumns($result);
            $this->AddInsertColumns($result);
            $this->AddPrintColumns($result);
            $this->AddExportColumns($result);
            $this->AddMultiUploadColumn($result);
    
    
            $this->SetShowPageList(true);
            $this->SetShowTopPageNavigator(true);
            $this->SetShowBottomPageNavigator(false);
            $this->setPrintListAvailable(true);
            $this->setPrintListRecordAvailable(false);
            $this->setPrintOneRecordAvailable(true);
            $this->setAllowPrintSelectedRecords(true);
            $this->setExportListAvailable(array('pdf', 'excel', 'word', 'xml', 'csv'));
            $this->setExportSelectedRecordsAvailable(array('pdf', 'excel', 'word', 'xml', 'csv'));
            $this->setExportListRecordAvailable(array());
            $this->setExportOneRecordAvailable(array('pdf', 'excel', 'word', 'xml', 'csv'));
    
            return $result;
        }
     
        protected function setClientSideEvents(Grid $grid) {
    
        }
    
        protected function doRegisterHandlers() {
            //
            // View column for gln field
            //
            $column = new TextViewColumn('gln', 'gln', 'GLN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_gln_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for type field
            //
            $column = new TextViewColumn('type', 'type', 'Typ', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_type_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('description', 'description', 'Beschreibung', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_description_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for street field
            //
            $column = new TextViewColumn('street', 'street', 'Straße', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_street_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for zip field
            //
            $column = new TextViewColumn('zip', 'zip', 'PLZ', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_zip_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for city field
            //
            $column = new TextViewColumn('city', 'city', 'Stadt', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_city_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for country field
            //
            $column = new TextViewColumn('country', 'country', 'Land', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_country_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for method_gln field
            //
            $column = new TextViewColumn('method_gln', 'method_gln', 'Verfahren GLN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_method_gln_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for method_text field
            //
            $column = new TextViewColumn('method_text', 'method_text', 'Verfahren Text', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_method_text_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('action_gln', 'LA1', 'Buchungsart', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_LA1_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('origin_site', 'LA2', 'Herkunft Anlage', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_LA2_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('destination_site', 'LA3', 'Verbleib Anlage', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_LA3_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('site_gln', 'LA4', 'Abfall GLN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_LA4_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for origin_single_msg_type field
            //
            $column = new TextViewColumn('origin_single_msg_type', 'origin_single_msg_type', 'Deponie Einzelmeldung', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_origin_single_msg_type_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for gln field
            //
            $column = new TextViewColumn('gln', 'gln', 'Gln', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_gln_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for type field
            //
            $column = new TextViewColumn('type', 'type', 'Typ', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_type_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('description', 'description', 'Description', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_description_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for street field
            //
            $column = new TextViewColumn('street', 'street', 'Straße', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_street_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for zip field
            //
            $column = new TextViewColumn('zip', 'zip', 'PLZ', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_zip_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for city field
            //
            $column = new TextViewColumn('city', 'city', 'Stadt', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_city_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for country field
            //
            $column = new TextViewColumn('country', 'country', 'Land', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_country_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for method_gln field
            //
            $column = new TextViewColumn('method_gln', 'method_gln', 'Method Gln', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_method_gln_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for method_text field
            //
            $column = new TextViewColumn('method_text', 'method_text', 'Verfahren Text', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_method_text_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('action_gln', 'LA1', 'Action Gln', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_LA1_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('origin_site', 'LA2', 'Origin Site', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_LA2_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('destination_site', 'LA3', 'Destination Site', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_LA3_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('site_gln', 'LA4', 'Abfall GLN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_LA4_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for origin_single_msg_type field
            //
            $column = new TextViewColumn('origin_single_msg_type', 'origin_single_msg_type', 'Deponie Einzelmeldung', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_origin_single_msg_type_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for gln field
            //
            $column = new TextViewColumn('gln', 'gln', 'GLN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_gln_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for type field
            //
            $column = new TextViewColumn('type', 'type', 'Typ', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_type_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('description', 'description', 'Beschreibung', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_description_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for street field
            //
            $column = new TextViewColumn('street', 'street', 'Straße', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_street_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for zip field
            //
            $column = new TextViewColumn('zip', 'zip', 'PLZ', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_zip_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for city field
            //
            $column = new TextViewColumn('city', 'city', 'Stadt', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_city_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for country field
            //
            $column = new TextViewColumn('country', 'country', 'Land', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_country_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for method_gln field
            //
            $column = new TextViewColumn('method_gln', 'method_gln', 'Verfahren GLN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_method_gln_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for method_text field
            //
            $column = new TextViewColumn('method_text', 'method_text', 'Verfahren Text', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_method_text_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('action_gln', 'LA1', 'Buchungsart', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_LA1_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('origin_site', 'LA2', 'Herkunft Anlage', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_LA2_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('destination_site', 'LA3', 'Verbleib Anlage', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_LA3_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('site_gln', 'LA4', 'Abfall GLN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_LA4_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for origin_single_msg_type field
            //
            $column = new TextViewColumn('origin_single_msg_type', 'origin_single_msg_type', 'Deponie Einzelmeldung', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_origin_single_msg_type_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'insert_public_contact_edm_gln_origin_site_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'insert_public_contact_edm_gln_destination_site_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qwaste_catalog"');
            $lookupDataset->addFields(
                array(
                    new StringField('gtin'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'insert_public_contact_edm_gln_site_gln_search', 'gtin', 'selector', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."tariff_edm_activity_types"');
            $lookupDataset->addFields(
                array(
                    new StringField('activity_type', true, true),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'filter_builder_public_contact_edm_gln_action_gln_search', 'activity_type', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'filter_builder_public_contact_edm_gln_origin_site_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'filter_builder_public_contact_edm_gln_destination_site_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qwaste_catalog"');
            $lookupDataset->addFields(
                array(
                    new StringField('gtin'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'filter_builder_public_contact_edm_gln_site_gln_search', 'gtin', 'selector', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for gln field
            //
            $column = new TextViewColumn('gln', 'gln', 'GLN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_gln_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for type field
            //
            $column = new TextViewColumn('type', 'type', 'Typ', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_type_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('description', 'description', 'Bezeichnung', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_description_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for street field
            //
            $column = new TextViewColumn('street', 'street', 'Straße', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_street_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for zip field
            //
            $column = new TextViewColumn('zip', 'zip', 'PLZ', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_zip_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for city field
            //
            $column = new TextViewColumn('city', 'city', 'Stadt', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_city_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for country field
            //
            $column = new TextViewColumn('country', 'country', 'Land', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_country_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for method_gln field
            //
            $column = new TextViewColumn('method_gln', 'method_gln', 'Verfahren GLN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_method_gln_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for method_text field
            //
            $column = new TextViewColumn('method_text', 'method_text', 'Verfahren Text', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_method_text_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('action_gln', 'LA1', 'Buchungsart', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_LA1_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('origin_site', 'LA2', 'Herkunft Anlage', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_LA2_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('destination_site', 'LA3', 'Verbleib Anlage', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_LA3_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('site_gln', 'LA4', 'Abfall GLN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_LA4_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for origin_single_msg_type field
            //
            $column = new TextViewColumn('origin_single_msg_type', 'origin_single_msg_type', 'Deponie Einzelmeldung', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_contact_edm_glnGrid_origin_single_msg_type_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'edit_public_contact_edm_gln_origin_site_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'edit_public_contact_edm_gln_destination_site_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qwaste_catalog"');
            $lookupDataset->addFields(
                array(
                    new StringField('gtin'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'edit_public_contact_edm_gln_site_gln_search', 'gtin', 'selector', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'multi_edit_public_contact_edm_gln_origin_site_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'multi_edit_public_contact_edm_gln_destination_site_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qwaste_catalog"');
            $lookupDataset->addFields(
                array(
                    new StringField('gtin'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'multi_edit_public_contact_edm_gln_site_gln_search', 'gtin', 'selector', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
        }
       
        protected function doCustomRenderColumn($fieldName, $fieldData, $rowData, &$customText, &$handled)
        { 
    
        }
    
        protected function doCustomRenderPrintColumn($fieldName, $fieldData, $rowData, &$customText, &$handled)
        { 
    
        }
    
        protected function doCustomRenderExportColumn($exportType, $fieldName, $fieldData, $rowData, &$customText, &$handled)
        { 
    
        }
    
        protected function doCustomDrawRow($rowData, &$cellFontColor, &$cellFontSize, &$cellBgColor, &$cellItalicAttr, &$cellBoldAttr)
        {
    
        }
    
        protected function doExtendedCustomDrawRow($rowData, &$rowCellStyles, &$rowStyles, &$rowClasses, &$cellClasses)
        {
    
        }
    
        protected function doCustomRenderTotal($totalValue, $aggregate, $columnName, &$customText, &$handled)
        {
    
        }
    
        protected function doCustomDefaultValues(&$values, &$handled) 
        {
    
        }
    
        protected function doCustomCompareColumn($columnName, $valueA, $valueB, &$result)
        {
    
        }
    
        protected function doBeforeInsertRecord($page, &$rowData, $tableName, &$cancel, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doBeforeUpdateRecord($page, $oldRowData, &$rowData, $tableName, &$cancel, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doBeforeDeleteRecord($page, &$rowData, $tableName, &$cancel, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doAfterInsertRecord($page, $rowData, $tableName, &$success, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doAfterUpdateRecord($page, $oldRowData, $rowData, $tableName, &$success, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doAfterDeleteRecord($page, $rowData, $tableName, &$success, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doCustomHTMLHeader($page, &$customHtmlHeaderText)
        { 
    
        }
    
        protected function doGetCustomTemplate($type, $part, $mode, &$result, &$params)
        {
    
        }
    
        protected function doGetCustomExportOptions(Page $page, $exportType, $rowData, &$options)
        {
    
        }
    
        protected function doFileUpload($fieldName, $rowData, &$result, &$accept, $originalFileName, $originalFileExtension, $fileSize, $tempFileName)
        {
    
        }
    
        protected function doPrepareChart(Chart $chart)
        {
    
        }
    
        protected function doPrepareColumnFilter(ColumnFilter $columnFilter)
        {
    
        }
    
        protected function doPrepareFilterBuilder(FilterBuilder $filterBuilder, FixedKeysArray $columns)
        {
    
        }
    
        protected function doGetSelectionFilters(FixedKeysArray $columns, &$result)
        {
    
        }
    
        protected function doGetCustomFormLayout($mode, FixedKeysArray $columns, FormLayout $layout)
        {
    
        }
    
        protected function doGetCustomColumnGroup(FixedKeysArray $columns, ViewColumnGroup $columnGroup)
        {
    
        }
    
        protected function doPageLoaded()
        {
    
        }
    
        protected function doCalculateFields($rowData, $fieldName, &$value)
        {
    
        }
    
        protected function doGetCustomPagePermissions(Page $page, PermissionSet &$permissions, &$handled)
        {
    
        }
    
        protected function doGetCustomRecordPermissions(Page $page, &$usingCondition, $rowData, &$allowEdit, &$allowDelete, &$mergeWithDefault, &$handled)
        {
    
        }
    
    }

    SetUpUserAuthorization();

    try
    {
        $Page = new public_contact_edm_glnPage("public_contact_edm_gln", "frmContact_edm_gln.php", GetCurrentUserPermissionSetForDataSource("public.contact_edm_gln"), 'UTF-8');
        $Page->SetRecordPermission(GetCurrentUserRecordPermissionsForDataSource("public.contact_edm_gln"));
        GetApplication()->SetMainPage($Page);
        GetApplication()->Run();
    }
    catch(Exception $e)
    {
        ShowErrorPage($e);
    }
	
