<!doctype html>
<?php
include('./include/config.inc.php');

if(!hasPermission("action_exit"))
{
	header('Location: index.php');
	die;
}

?>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="user-scalable=no, initial-scale=1, maximum-scale=1, minimum-scale=1, width=device-width">
	<meta name="mobile-web-app-capable" content="yes">
	<meta name="apple-mobile-web-app-capable" content="yes">
	<meta http-equiv="X-UA-Compatible" content="IE=edge"/>	
	<title>Waste Management System</title>
	<link rel="shortcut icon" href="favicon.ico">
	<link rel="stylesheet" href="css/jquery.mobile.structure.css">
	<link rel="stylesheet" href="css/jquery.mobile.theme.css">
	<link rel="stylesheet" href="css/jquery.mobile.icons.css">
	<link rel="stylesheet" href="css/wms.css">
	<link rel="stylesheet" href="css/wms.add.css">
	<script src="js/jquery.js"></script>
	<script src="js/jquery.mobile.js"></script>
	<script src="js/wms.js"></script>
			<script>
		$( document ).on( "click", ".show-page-loading-msg", function() {
			$("#report").fadeOut();
			var $this = $( this ),
				theme = $this.jqmData( "theme" ) || $.mobile.loader.prototype.options.theme,
				msgText = $this.jqmData( "msgtext" ) || $.mobile.loader.prototype.options.text,
				textVisible = $this.jqmData( "textvisible" ) || $.mobile.loader.prototype.options.textVisible,
				textonly = !!$this.jqmData( "textonly" );
				html = $this.jqmData( "html" ) || "";
			$.mobile.loading( "show", {
					text: msgText,
					textVisible: textVisible,
					theme: theme,
					textonly: textonly,
					html: html
			});			
		})
		.on( "click", ".hide-page-loading-msg", function() {
			$.mobile.loading( "hide" );
		});
	</script>
</head>
<body>

<div data-role="page">
	<?php
	include('js/header.php');
	?>
	<?php
	include('js/menu.php');
	?>
	<div role="main" class="ui-content">
		<?php
		
		$rep = pg_query($db, 'select field from preset where section = \'report\' and param = \'invoice\'');
		$reprow = pg_fetch_assoc($rep);	
		
		if (isset($_GET['printonly']))
		{
			$printonly = $_GET['printonly'];
		}
		else
		{
			$printonly = 'no';
		}
							
		?>
		<p>Rechnungsdruck zu Rechnung <?php echo substr($_GET['id'], 0, 4).'/'.substr($_GET['id'], 4, strlen($_GET['id']) - 4) ?>!</p>
		
		<form id="report" data-ajax="false" name="report" action="print_render.php?printonly=<?php echo $printonly; ?>" method="POST">
		<input type="hidden" name="report" value="<?php echo $reprow['field']; ?>">

		<?php
		
			$grossrec = pg_query($db, 'select to_char(sum(gross_amount), \'999G990D00\') as gross from invoice_item where year = '.substr($_GET['id'], 0, 4).' and nr = '.substr($_GET['id'], 4, strlen($_GET['id']) - 4));
			$ig = pg_fetch_assoc($grossrec);
			
			$gross = $ig['gross'];					
		
			$inv = pg_query($db, 'select i.name1, i.name2, i.address1, i.address2, i.paymenttype, i.contact, c.debitor_id from invoice i join contact c on c.id = i.contact where year = '.substr($_GET['id'], 0, 4).' and nr = '.substr($_GET['id'], 4, strlen($_GET['id']) - 4));
			$ir = pg_fetch_assoc($inv);
			
			if ($printonly == 'no')
			{
				echo 'Nachname: <input type="text" name="name1" placeholder="Nachname" value="'.trim($ir['name1']).'">';
				echo 'Vorname: <input type="text" name="name2" placeholder="Vorname" value="'.trim($ir['name2']).'">';
				echo 'Straße: <input type="text" name="address1" placeholder="Straße" value="'.trim($ir['address1']).'">';
				echo 'PLZ Ort: <input type="text" name="address2" placeholder="PLZ Ort" value="'.trim($ir['address2']).'">';
                echo 'Debitor: <input type="text" readonly name="debitor_id" placeholder="Debitor" value="'.trim($ir['debitor_id']).'">';
			}
			
			$paym = $ir['paymenttype'];
		
			$prn_select = pg_query($db, 'select field from preset where section = \'report\' and param = \'printer_select\'');
			$rec_select = pg_fetch_assoc($prn_select);		
		
  			echo '<input type="hidden" name="prmYear" value="'.substr($_GET['id'], 0, 4).'">';
  			echo '<input type="hidden" name="prmNr" value="'.intval(substr($_GET['id'], 4, strlen($_GET['id']) - 4)).'">';
  			echo '<input type="hidden" name="followup" value="wms_cash">';
			echo '<input type="hidden" name="contact" id="contact" value="'.$ir['contact'].'">';  				
  			echo $rec_select['field'];
 
		?>
		
		<select value="<?php echo $paym; ?>" required id="zahlung" name="zahlung" data-native-menu="false">
		<option data-placeholder="true">--- Zahlungsart wählen ---</option>
		<?php
		if (trim($ir['debitor_id']) <> "")
		{
			$res = pg_query($db, 'select id, description from paymenttype where debitor is not null order by description');
		}
		else
		{
			$res = pg_query($db, 'select id, description from paymenttype where debitor is not null and debitor <> \'-\' order by description');
		}
		while ($row = pg_fetch_assoc($res)) {
		?>
			<option
				<?php if ($row['id'] == $paym) echo 'selected '; ?> 
				value=<?php echo $row['id']; ?>>
			<?php echo $row['description']; ?>
			</option>
		<?php } ?>		
		</select>
		
		Gesamtbetrag: 
		<input type="text" name="gross" placeholder="Gesamt" value="<?php echo trim($gross); ?>">

		Betrag gegeben: 
		<input type="text" name="got_gross" placeholder="Betrag gegeben" value="0">
		
		<br>
		
		<input type="submit" data-textonly="false" data-textvisible="true" data-msgtext="Rechnung wird gedruckt! Bitte warten ..." class="show-page-loading-msg  ui-shadow ui-btn ui-corner-all" value="Weiter">

		</form>
		 
	</div>
	
	<?php
	include('js/footer.php');
	?>
	
</div>

</body>
</html>
